package pole2djednotkovamaticenahradacisladelitelnatremi;

import java.util.InputMismatchException;
import java.util.Scanner;

/**
 * Program vytvoří dvourozměrné pole s celočíselnými prvky o rozměru 3 × 3, tj.
 * o 3 řádcích a 3 sloupcích. Prvky pole budou číslice 1 a 0, uspořádáním budou
 * tvořit jednotkovou matici. (Pozn. Jednotkovou maticí velikosti n označujeme
 * čtvercovou matici n × n, která má na hlavní diagonále jedničky a na ostatních
 * místech nuly.) Dále nahradí všechny nuly v tomto dvourozměrném poli celým
 * číslem, které zadá uživatel po vyzvání z klávesnice. Spočte v tomto
 * dvourozměrném poli počet všech prvků dělitelných třemi. Výstupem budou prvky
 * dělitelné třemi, jejich pozice (řádek, sloupec) v poli a počet těchto prvků.
 * (Pozn. Celé číslo p je dělitelné nenulovým celým číslem q, jestliže existuje
 * takové celé číslo k, pro které platí, že p = k∙q, tzn., že zbytek po dělení p
 * / q je nula.)
 *
 * @author lsroubov
 */
public class Pole2dJednotkovaMaticeNahradaCislaDelitelnaTremi {

    public static int nactiCislo(Scanner klavesnice, String hlaska) {
        int cislo;
        while (true) {
            try {
                System.out.format(hlaska);
                cislo = klavesnice.nextInt();
                return cislo;
            } catch (InputMismatchException ex) {
                System.out.format("Je nutno zadat celé číslo.%n");
                klavesnice.nextLine();
            }
        }
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int[][] pole2d = new int[3][3];

        System.out.println("Jednotkova matice:");
        for (int r = 0; r < pole2d.length; r++) {
            for (int s = 0; s < pole2d[r].length; s++) {
                pole2d[r][s] = (r == s) ? 1 : 0;
                System.out.printf("%5d\t", pole2d[r][s]);
            }
            System.out.println();
        }
        System.out.println("Zadani cisel misto nul:");
        for (int r = 0; r < pole2d.length; r++) {
            for (int s = 0; s < pole2d[r].length; s++) {
                if (r != s) {
                    pole2d[r][s] = nactiCislo(sc, String.format("Zadej prvek na pozici [%d][%d]: ", r, s));
                }
            }
        }
        System.out.println("Nahrazena matice:");
        for (int r = 0; r < pole2d.length; r++) {
            for (int s = 0; s < pole2d[r].length; s++) {
                System.out.printf("%5d\t", pole2d[r][s]);
            }
            System.out.println();
        }
        int pocetDelitelnych3 = 0;
        System.out.println("Prvky delitelne tremi:");
        for (int r = 0; r < pole2d.length; r++) {
            for (int s = 0; s < pole2d[r].length; s++) {
                if (pole2d[r][s] % 3 == 0) {
                    System.out.printf("Prvek %5d na pozici [%d][%d] je delitelny tremi\n", pole2d[r][s], r, s);
                    pocetDelitelnych3++;
                }
            }
        }
        System.out.println("Pocet prvku delitelnych tremi je: " + pocetDelitelnych3);
    }
}
